Bug 103075 - RenderBox::computePercentageLogicalHeight should use containingBlockLogicalWidthForContent
Summary: RenderBox::computePercentageLogicalHeight should use containingBlockLogicalWi...
Status: RESOLVED FIXED
Alias: None
Product: WebKit
Classification: Unclassified
Component: Layout and Rendering (show other bugs)
Version: 528+ (Nightly build)
Hardware: All All
: P2 Normal
Assignee: Julien Chaffraix
URL:
Keywords:
Depends on:
Blocks: 102968
  Show dependency treegraph
 
Reported: 2012-11-22 08:57 PST by Julien Chaffraix
Modified: 2012-11-26 11:08 PST (History)
6 users (show)

See Also:


Attachments
Proposed change. (7.18 KB, patch)
2012-11-22 09:21 PST, Julien Chaffraix
no flags Details | Formatted Diff | Diff
Updated patch: As we may use one of our ancestor's containing block, we need to call the function on it. (8.04 KB, patch)
2012-11-23 10:03 PST, Julien Chaffraix
no flags Details | Formatted Diff | Diff
Rebaselined change for the EWS. (7.94 KB, patch)
2012-11-23 10:49 PST, Julien Chaffraix
no flags Details | Formatted Diff | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Julien Chaffraix 2012-11-22 08:57:22 PST
Currently the code is the following:

if (isHorizontalWritingMode() != cb->isHorizontalWritingMode())
    availableHeight = cb->contentLogicalWidth();

(http://trac.webkit.org/browser/trunk/Source/WebCore/rendering/RenderBox.cpp#L2209)

This is right for most renderers but there are some special cases:
* captions need to match the table's logical width, not the table's content logical width.
* multi-column renderers need to constrain the logical width to match the column size.

Those 2 cases are broken in ToT when we have orthogonal writing modes.
Comment 1 Julien Chaffraix 2012-11-22 09:21:17 PST
Created attachment 175686 [details]
Proposed change.
Comment 2 Build Bot 2012-11-22 12:12:39 PST
Comment on attachment 175686 [details]
Proposed change.

Attachment 175686 [details] did not pass mac-ews (mac):
Output: http://queues.webkit.org/results/14937466

New failing tests:
fast/table/height-percent-test-vertical.html
Comment 3 Ojan Vafai 2012-11-22 12:36:37 PST
(In reply to comment #2)
> New failing tests:
> fast/table/height-percent-test-vertical.html

Looks likely this is a real failure.
Comment 4 WebKit Review Bot 2012-11-22 23:21:47 PST
Comment on attachment 175686 [details]
Proposed change.

Attachment 175686 [details] did not pass chromium-ews (chromium-xvfb):
Output: http://queues.webkit.org/results/14967609

New failing tests:
fast/table/height-percent-test-vertical.html
inspector-protocol/debugger-terminate-dedicated-worker-while-paused.html
Comment 5 Julien Chaffraix 2012-11-23 10:03:21 PST
Created attachment 175825 [details]
Updated patch: As we may use one of our ancestor's containing block, we need to call the function on it.
Comment 6 Julien Chaffraix 2012-11-23 10:49:39 PST
Created attachment 175827 [details]
Rebaselined change for the EWS.
Comment 7 WebKit Review Bot 2012-11-26 11:08:07 PST
Comment on attachment 175827 [details]
Rebaselined change for the EWS.

Clearing flags on attachment: 175827

Committed r135741: <http://trac.webkit.org/changeset/135741>
Comment 8 WebKit Review Bot 2012-11-26 11:08:11 PST
All reviewed patches have been landed.  Closing bug.